import { OnInit, ElementRef } from '@angular/core';
export declare class StickySidebarComponent implements OnInit {
    private _hostElementRef;
    customTopOffset: number;
    wrapperElementRef: ElementRef;
    private _containerElement;
    private _wrapperElement;
    private _initialTopOffset;
    private _scrollTop;
    private _scrollDirection;
    constructor(_hostElementRef: ElementRef);
    containerSelector: string;
    ngOnInit(): void;
    /**
     * Resets sidebar based on current conditions.
     */
    reset(): void;
    /**
     * Ensures the minimum height of the sidebar is the same as the container
     * when floats are used.
     */
    setSidebarHeight(height?: number): void;
    /**
     * Initializes the "top" CSS property of the wrapper element.
     */
    initTopOffset(): void;
    /**
     * Watches the scroll event and adjusts the "top" CSS property of the wrapper
     * element.
     */
    addScrollListener(): void;
    /**
     * Watches the window.resize event and resets sidebar.
     */
    addResizeListener(): void;
    /**
     * Returns the height of an element without padding or borders.
     * @param element The element to use.
     * @param limitToViewport Whether to use the full height or limit the height
     *                        to the height of the viewport.
     */
    getContentBoxHeight(element: HTMLElement, limitToViewport?: boolean): number;
}
